// Generated by CoffeeScript 1.7.1
(function() {
  var colors, func, funcs, height, line, margin, svg, width, x, xs, xse, y, yse, _i, _len, _ref, _ref1;

  margin = {
    top: 20,
    right: 20,
    bottom: 30,
    left: 50
  };

  width = 960 - margin.left - margin.right;

  height = 500 - margin.top - margin.bottom;

  svg = d3.select('#scales svg').attr('width', width + margin.left + margin.right).attr('height', height + margin.top + margin.bottom).append('g').attr('transform', 'translate(' + margin.left + ',' + margin.top + ')');

  x = d3.scale.linear().range([0, width]);

  y = d3.scale.linear().range([height, 0]);

  line = d3.svg.line().x(function(d) {
    return x(d.x);
  }).y(function(d) {
    return y(d.y);
  });

  xs = d3.range(1, 100);

  _ref = [d3.extent(xs), [0, 100]], xse = _ref[0], yse = _ref[1];

  x.domain(xse);

  y.domain(yse);

  funcs = {
    log: d3.scale.log(),
    sqrt: d3.scale.sqrt(),
    linear: d3.scale.linear(),
    'pow(2)': d3.scale.pow().exponent(2),
    'pow(4)': d3.scale.pow().exponent(4),
    'pow(10)': d3.scale.pow().exponent(10),
    'pow(0.2)': d3.scale.pow().exponent(0.2)
  };

  _ref1 = d3.values(funcs);
  for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
    func = _ref1[_i];
    func.range(yse).domain(xse);
  }

  colors = d3.scale.category20();

  svg.selectAll('path').data(d3.entries(funcs)).enter().append('path').datum(function(d) {
    var v, _j, _len1, _results;
    _results = [];
    for (_j = 0, _len1 = xs.length; _j < _len1; _j++) {
      v = xs[_j];
      _results.push({
        x: v,
        y: d.value(v),
        name: d.key
      });
    }
    return _results;
  }).attr('class', 'data').attr('d', line).style('stroke', function(d) {
    return colors(d[0].name);
  });

  d3.select('#scales .legend').selectAll('li').data(d3.keys(funcs)).enter().append('li').text(function(d) {
    return d;
  }).style('color', function(d) {
    return colors(d);
  });

  svg.append('g').attr('class', 'x axis').attr('transform', 'translate(0,' + height + ')').call(d3.svg.axis().scale(x).orient('bottom'));

  svg.append('g').attr('class', 'y axis').call(d3.svg.axis().scale(y).orient('left'));

}).call(this);
